----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date: 16.05.2017 21:51:02
-- Design Name: 
-- Module Name: ip - Behavioral
-- Project Name: 
-- Target Devices: 
-- Tool Versions: 
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
----------------------------------------------------------------------------------


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.NUMERIC_STD.ALL;
-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values


-- Uncomment the following library declaration if instantiating
-- any Xilinx leaf cells in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity IPosc is
    Port (selx : in STD_LOGIC_VECTOR (1 downto 0);
          sely : in STD_LOGIC_VECTOR (1 downto 0);
          adr : in unsigned (9 downto 0);
          dataout : out signed (8 downto 0);
          s1 : in STD_LOGIC;
          clk : in STD_LOGIC;
          data : in signed (13 downto 0)
    );
end IPosc;

architecture Behavioral of IPosc is
component izbirnik is
Port ( selx : in STD_LOGIC_VECTOR (1 downto 0);
           dout : out signed (9 downto 0);
           oe : out STD_LOGIC;
           clk : in STD_LOGIC;
           din : in signed (9 downto 0));
end component;
component skaliranje is           
Port ( data : in signed (13 downto 0);
          sely : in STD_LOGIC_VECTOR (1 downto 0);
          clk : in STD_LOGIC;
          dout : out signed (8 downto 0));
end component;

type mem is array(0 to 1023) of signed(8 downto 0);
signal ram: mem :=(others=>(others=>'0'));
type stanja is (mir,start,start1,zajem);
signal st:stanja;
signal oe, s2, s3 :  STD_LOGIC;
signal doutskal :  signed (8 downto 0);
signal doutskalprej :  signed (8 downto 0);
signal dinizb :  signed (9 downto 0);
signal doutizb :  signed (9 downto 0);
signal doutizb1 :  signed (8 downto 0);
--shared variable 
signal n1 : unsigned(9 downto 0):="0000000000";
begin
dinizb<=resize(doutskal,10);
doutizb1<=resize(doutizb,9);
sk:skaliranje port map(data=>data, sely=>sely, clk=>clk, dout=>doutskal);
iz:izbirnik port map(din=>dinizb, selx=>selx ,clk=>clk, dout=>doutizb, oe=>oe);

dataout<=ram(to_integer(unsigned(adr)));
process(clk)
begin
if rising_edge(clk)then
s2 <= s1;
s3 <= s2;

case st is
    when mir=>
        if s3='1' and s2='0' then -- rising edge (s1)
        st<=start; 
        end if;
    when start=> 
        n1<=(others=>'0');
   	    if oe='1' then
			doutskalprej <= doutskal;
			st<= start1;
		end if;
	when start1=>
        if oe='1' then
		    doutskalprej <= doutskal;
			if doutskalprej<=0 and doutskal>0 then
               st<= zajem;
            end if;			
		end if;				
   when others=>
        if st=zajem and oe='1' and n1<1023 then
        ram(to_integer(n1))<=doutizb1;
        n1<=n1+1; 
        elsif n1=1023 then
        n1<=(others=>'0');
       st<=mir;     
        end if;
end case;
end if;
end process;       

end Behavioral;
