----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date: 23.04.2017 09:53:23
-- Design Name: 
-- Module Name: izbirnik - Behavioral
-- Project Name: 
-- Target Devices: 
-- Tool Versions: 
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
----------------------------------------------------------------------------------




library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx leaf cells in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity izbirnik is
    Port ( selx : in STD_LOGIC_VECTOR (1 downto 0);
           dout : out signed (9 downto 0);
           oe : out STD_LOGIC;
           clk : in STD_LOGIC;
           din : in signed (9 downto 0));
end izbirnik;

architecture Behavioral of izbirnik is
component decimacija is
Port ( x : in signed (9 downto 0);
           y : out signed (9 downto 0);
           oe : out STD_LOGIC;
           clk : in STD_LOGIC;
           ce : in STD_LOGIC);
  end component;
  signal y1,y2,y3: signed (9 downto 0);
  signal oe1,oe2,oe3: STD_LOGIC;
begin
sito1:decimacija port map(x=>din,ce=>'1',clk=>clk,y=>y1,oe=>oe1);
sito2:decimacija port map(x=>y1,ce=>oe1,clk=>clk,y=>y2,oe=>oe2);
sito3:decimacija port map(x=>y2,ce=>oe2,clk=>clk,y=>y3,oe=>oe3);
process(selx,din,y1,y2,y3,oe1,oe2,oe3)
begin
case selx is
when "00"=>
    dout<=din;
    oe<='1';
when "01"=>
        dout<=y1;
        oe<=oe1;
when "10"=>
     dout<=y2;
    oe<=oe2;  
when others=>
    dout<=y3;
    oe<=oe3;                 

end case;
end process;


end Behavioral;