----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date: 08.05.2017 21:07:13
-- Design Name: 
-- Module Name: skaliranje - Behavioral
-- Project Name: 
-- Target Devices: 
-- Tool Versions: 
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
----------------------------------------------------------------------------------


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx leaf cells in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity skaliranje is
    Port ( data : in signed (13 downto 0);
           sely : in STD_LOGIC_VECTOR (1 downto 0);
           clk : in STD_LOGIC;
           dout : out signed (8 downto 0));
end skaliranje;

architecture Behavioral of skaliranje is
signal izhod : signed (8 downto 0);
signal data1 : signed (17 downto 0);

begin

process(clk)
begin
if rising_edge(clk)then

case sely is
    when "00"=>
        if data>to_signed(8191,14)then
        izhod<=to_signed(255,9);
        elsif data<to_signed(-8192,14)then
         izhod<=to_signed(-256,9);
        else izhod<=data(13 downto 5);
        end if;
    when "01"=>
       if data>to_signed(2047,14)then
            izhod<=to_signed(255,9);
            elsif data<to_signed(-2048,14)then
             izhod<=to_signed(-256,9);
            else izhod<=resize(data(13 downto 3),9);
            end if;
    when "10"=>
       if data>to_signed(817,14)then
            izhod<=to_signed(255,9);
            elsif data<to_signed(-822,14)then
             izhod<=to_signed(-256,9);
            else data1<=data*to_signed(5,4);
            izhod<=resize(data1(17 downto 4),9);
            end if;
    when others=>
       if data>to_signed(204,14)then
            izhod<=to_signed(255,9);
            elsif data<to_signed(-204,14)then
             izhod<=to_signed(-256,9);
            else 
            data1<=data*to_signed(5,4);
            izhod<=resize(data1(17 downto 2),9);
            end if;
end case;
end if;
end process;

dout<=izhod;

end Behavioral;
